---
layout: layouts/exercise_base.njk
exercise: Pedestrian Crossing
points:
---
In this lab session we'll build a <a href="">puffin crossing</a>. Complete
all of the following tasks.
<ol>
  <li><strong>Basic traffic light</strong><br />
    Using the available components (or the
    <a href="https://wokwi.com/">Wokwi simulator</a>) create a single traffic
    light for cars (green, yellow, red). Run this traffic light controller in
    an endless loop.
  </li>
  <li><strong>Pedestrian crossing</strong><br />
    Add a button for a pedestrian to press. Implement a handler function
    that should be called when the button is pressed. Make the button handler
    interrupt the regular program execution by triggering an interrupt request.
    Modify your original traffic light such that, when the button was pressed,
    the red light will light up longer. In addition, add a green light for
    pedestrians.
  </li>
  <li><strong>Dealing with visually impaired people</strong><br />
    Add a buzzer to the system that helps visually impaired people to cross
    the street safely.
  </li>
</ol>
